package com.huimv.devicedata.service.impl;

import com.alibaba.fastjson.JSONObject;

import com.huimv.devicedata.entity.DeviceUpdataEntity;
import com.huimv.devicedata.repo.DeviceUpdataEntityRepository;
import com.huimv.devicedata.service.IDeviceDataService;
import com.huimv.devicedata.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
public class DeviceDataServiceImpl implements IDeviceDataService {

    @Autowired
    private DeviceUpdataEntityRepository deviceUpdataEntityRepo;
    @Autowired
    private DateUtil dateUtil;

    @Override
    public void saveDeviceChangedUpData(JSONObject deviceUpDataJo) {
        String productId = deviceUpDataJo.getString("productId");
        String deviceId = deviceUpDataJo.getString("deviceId");
        long timestamp = deviceUpDataJo.getLong("timestamp");
        String upDataDate = dateUtil.formatLongDate(timestamp);
        String serviceId = deviceUpDataJo.getString("serviceId");
        String imsi = deviceUpDataJo.getString("IMSI");
        String imei = deviceUpDataJo.getString("IMEI");
        String deviceType = deviceUpDataJo.getString("deviceType");
        String messageType = deviceUpDataJo.getString("messageType");
        String protocol = deviceUpDataJo.getString("protocol");
        String tenantId = deviceUpDataJo.getString("tenantId");
        JSONObject businessDataJo = deviceUpDataJo.getJSONObject("payload");
        int dataVer = businessDataJo.getInteger("VER");
        int dataTime = businessDataJo.getInteger("TIME");
        int dataTemp = businessDataJo.getInteger("TEMP");
        int dataStc = businessDataJo.getInteger("STC");
        int dataRssi = businessDataJo.getInteger("RSSI");
        int dataHumi = businessDataJo.getInteger("HUMI");
        int dataBat = businessDataJo.getInteger("BAT");
        DeviceUpdataEntity deviceUpdataEntity = new DeviceUpdataEntity();
        deviceUpdataEntity.setProductId(productId);
        deviceUpdataEntity.setDeviceId(deviceId);
        deviceUpdataEntity.setTimestamp(upDataDate);
        deviceUpdataEntity.setServiceId(serviceId);
        deviceUpdataEntity.setImei(imei);
        deviceUpdataEntity.setImsi(imsi);
        deviceUpdataEntity.setDeviceType(deviceType);
        deviceUpdataEntity.setMessageType(messageType);
        deviceUpdataEntity.setProtocol(protocol);
        deviceUpdataEntity.setDataVer(dataVer);
        deviceUpdataEntity.setDataTime(dataTime);
        deviceUpdataEntity.setDataTemp(dataTemp);
        deviceUpdataEntity.setDataStc(dataStc);
        deviceUpdataEntity.setDataRssi(dataRssi);
        deviceUpdataEntity.setDataHumi(dataHumi);
        deviceUpdataEntity.setDataBat(dataBat);
        deviceUpdataEntity.setTenantId(tenantId);
        //
        deviceUpdataEntityRepo.saveAndFlush(deviceUpdataEntity);
    }
}

